//+------------------------------------------------------------------+
//|                                                1 Trade a Day.mq4 |
//|                                                Copyright  2009. |
//|                                           http://strategy4you.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009."
#property link      "http://strategy4you.ru"
#define Magic       20100225
#define h2s         3600
extern double Lot=0.0;            //     ( 0 -  )
extern int    MaxRisk=2;          // %   (  )
extern int    GMTShift=1;         //     GMT
extern string StartTime="00:00";  //   ( GMT)
extern string EndTime="08:59";    //   ( GMT)
extern int    Delta=10;           //    
extern int    NoTrade=120;        //      (0- )
extern int    TPSize=100;         //  ( %  )
extern int    SLSize=100;         //  ( %  )
extern int    ClosePos=0;         //   :
                                  // 0 - 
                                  // 1 -    
                                  // 2 -       
extern bool   DelRorder=true;     //      
extern bool   ShowWarn=true;      //   
string StrategyName="1 Trade a Day";
bool   work=true;
string error;
int d=0;
//+------------------------------------------------------------------+
int init()
{if(Lot!=0 && Lot<MarketInfo(Symbol(),MODE_MINLOT))
   {Alert("   !"); work=false;}
 if(Lot!=0 && Lot>MarketInfo(Symbol(),MODE_MAXLOT))
   {Alert("   !"); work=false;}
 if(Lot==0 && MaxRisk<1)
   {Alert("  %      !"); work=false;}
 if(Lot==0 && MaxRisk>100)
   {Alert("  %      !"); work=false;}
return(0);}
//+------------------------------------------------------------------+
int deinit() {Comment("");return(0);}
//+------------------------------------------------------------------+
int start()
{if(!work) {Comment("  !  ."); return(0);}
 if(DayOfWeek()==0 || DayOfWeek()==6) return(0); //    
 if(!IsTradeAllowed()) return(0); //     
 double mLot=Lot;
 if(Lot==0.0) mLot=GetOptimalLot(MaxRisk);
 Comment("http://strategy4you.ru");
//...     
 int oCount=0,sCount=0,Ticket=0;
 for(int i=OrdersTotal()-1;i>=0;i--)
   if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
     if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
       {if(OrderType()==OP_BUY || OrderType()==OP_SELL) oCount++;
        if(OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP) {sCount++;Ticket=OrderTicket();}}
 if(oCount>0 && DelRorder)
   if(OrderSelect(Ticket,SELECT_BY_TICKET)) DelOrder();
//...    
 if(d==TimeDay(TimeCurrent())) return(0);
//... 
 if(oCount+sCount>0 && ClosePos>0)
   {if(ClosePos==1) CloseAll();
    if(ClosePos==2 && oCount>0)
      {for(i=OrdersTotal()-1;i>=0;i--)
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
           if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
             {if(OrderType()==OP_BUY && OrderStopLoss()<OrderOpenPrice() && Ask>OrderOpenPrice())
                EditOrder(OrderOpenPrice()+Point);
              if(OrderType()==OP_SELL && OrderStopLoss()>OrderOpenPrice() && Bid<OrderOpenPrice())
                EditOrder(OrderOpenPrice()-Point);}
      }
   }
//... 
 if(TimeCurrent()<StrToTime(StartTime+":00")+GMTShift*h2s) return(0);
 int sBar=iBarShift(NULL,0,StrToTime(StartTime+":00")+GMTShift*h2s);
 int eBar=iBarShift(NULL,0,StrToTime(EndTime+":59")+GMTShift*h2s);
 int cBar=sBar-eBar+1;
 double h=NormalizeDouble(High[iHighest(NULL,0,MODE_HIGH,cBar,eBar)],Digits);
 double l=NormalizeDouble(Low[iLowest(NULL,0,MODE_LOW,cBar,eBar)],Digits);
 double Box=h-l;
 double u=h+Delta*Point;
 double z=l-Delta*Point;
 if(TimeCurrent()<=StrToTime(EndTime+":59")+GMTShift*h2s) return(0);
//...    
 if(oCount+sCount>0) {d=TimeDay(TimeCurrent());return(0);}
//...  
 if(NoTrade>0 && Box>NoTrade*Point)
   {int r=Box/Point;
    error=" : "+r+"  : "+NoTrade+"!  .";
    if(ShowWarn) Alert(error);
    Print(error);
    d=TimeDay(TimeCurrent());
    return(0);}
//... 
 double a=NormalizeDouble(Ask,Digits);
 double b=NormalizeDouble(Bid,Digits);
 double level=MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
 if((u-a)<level)
   {error="     !   .";
    if(ShowWarn) Alert(error);
    Print(error);
    u=a+level+2*Point;}
 if((b-z)<level)
   {error="     !   .";
    if(ShowWarn) Alert(error);
    Print(error);
    z=b-level-2*Point;}
 NewOrder(OP_BUYSTOP,mLot,u,h+(Box*TPSize/100),h-(Box*SLSize/100));
 NewOrder(OP_SELLSTOP,mLot,z,l-(Box*TPSize/100),l+(Box*SLSize/100));
 d=TimeDay(TimeCurrent());
//...
return(0);}
//+------------------------------------------------------------------+
int NewOrder(int Cmd,double lot,double pr,double tp=0,double sl=0)
{int tick=0;
 for(int er=0;er<3;er++)
   {while(!IsTradeAllowed()) Sleep(100);
    tick=OrderSend(Symbol(),Cmd,lot,pr,3,sl,tp,StrategyName,Magic,0,CLR_NONE);
    if(tick>0) break;
    Print("#",OrderTicket(),"  Error: ",GetLastError()," Function: NewOrder(",Cmd,",",lot,",",pr,",",tp,",",sl,") ",er);
    Sleep(1000);}
return(tick);}
//+------------------------------------------------------------------+
void EditOrder(double sl)
{for(int er=0;er<3;er++)
  {while(!IsTradeAllowed()) Sleep(100);
   if(OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE)) break;
   Print("#",OrderTicket(),"  Error: ",GetLastError()," Function: EditOrder(",sl,") ",er);
   Sleep(1000);}}
//+------------------------------------------------------------------+
void DelOrder()
{for(int er=0;er<3;er++)
  {while(!IsTradeAllowed()) Sleep(100);
   if(OrderDelete(OrderTicket(),CLR_NONE)) break;
   Print("#",OrderTicket(),"  Error: ",GetLastError()," Function: DelOrder() ",er);
   Sleep(1000);}}
//+------------------------------------------------------------------+
void CloseOrder(double lot=0)
{double pr=0,a=0,b=0,l=0;
 for(int er=0;er<3;er++)
   {while(!IsTradeAllowed()) Sleep(100);
    if(OrderType()==OP_BUY)  pr=NormalizeDouble(Bid,Digits);
    if(OrderType()==OP_SELL) pr=NormalizeDouble(Ask,Digits);
    if(lot==0) l=OrderLots();
    if(OrderClose(OrderTicket(),l,pr,3,CLR_NONE)) break;
    Print("#",OrderTicket(),"  Error: ",GetLastError()," Function: CloseOrder(",lot,") ",er);
    Sleep(1000);}}
//+------------------------------------------------------------------+
void CloseAll()
{for(int i=OrdersTotal()-1;i>=0;i--)
   if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
     if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
       {if(OrderType()==OP_BUY || OrderType()==OP_SELL) CloseOrder();
        if(OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP) DelOrder();}}
//+------------------------------------------------------------------+
double NormLot(double lot)
{double Min_Lot=MarketInfo(Symbol(),MODE_MINLOT);
 double Max_Lot=MarketInfo(Symbol(),MODE_MAXLOT);
 double Step   =MarketInfo(Symbol(),MODE_LOTSTEP);
 int    DigLot =0;
 if(Step<0.1)  DigLot=2;
 if(Step>=0.1) DigLot=1;
 if(Step>=1)   DigLot=0;
 if(lot<Min_Lot) lot=Min_Lot;
 if(lot>Max_Lot) lot=Max_Lot;
return(NormalizeDouble(lot,DigLot));}
//+------------------------------------------------------------------+
double GetOptimalLot(int Percent)
{double Free    =AccountFreeMargin();
 double One_Lot =MarketInfo(Symbol(),MODE_MARGINREQUIRED);
 double Step    =MarketInfo(Symbol(),MODE_LOTSTEP);
 double Lots_New=MathFloor(Free*Percent/100/One_Lot/Step)*Step;
return(NormLot(Lots_New));}
//+------------------------------------------------------------------+